]> oss.titaniummirror.com Git - cp210x.git/commitdiff
This is the original version as sent by Silicon Labs. It was an older version
authorsmckown <smckown@986fd584-583e-0410-b54d-b9fe63dff8e5>
Wed, 7 Nov 2007 15:47:46 +0000 (15:47 +0000)
committersmckown <smckown@986fd584-583e-0410-b54d-b9fe63dff8e5>
Wed, 7 Nov 2007 15:47:46 +0000 (15:47 +0000)
than was already included in the linux kernel at the time.

15 files changed:
Docs/SIL00205 design.doc [new file with mode: 0644]
Docs/SIL00205_RNF_20060115.doc [new file with mode: 0644]
Docs/SIL00205_RNF_20060901.doc [new file with mode: 0644]
Docs/igx_to_2_6_15_1_diff.txt [new file with mode: 0644]
Makefile [new file with mode: 0644]
Makefile.go [new file with mode: 0644]
Makefile24 [new file with mode: 0644]
Makefile26 [new file with mode: 0644]
Modules.symvers [new file with mode: 0644]
Rules.make [new file with mode: 0644]
configure [new file with mode: 0755]
cp2101.c [new file with mode: 0644]
installmod [new file with mode: 0644]
rpm/buildRPM [new file with mode: 0755]
rpm/cp2103.spec [new file with mode: 0644]

diff --git a/Docs/SIL00205 design.doc b/Docs/SIL00205 design.doc
new file mode 100644 (file)
index 0000000..3599f1b
--- /dev/null
@@ -0,0 +1 @@
+ÐÏ\11ࡱ
\ No newline at end of file
diff --git a/Docs/SIL00205_RNF_20060115.doc b/Docs/SIL00205_RNF_20060115.doc
new file mode 100644 (file)
index 0000000..f3a7444
Binary files /dev/null and b/Docs/SIL00205_RNF_20060115.doc differ
diff --git a/Docs/SIL00205_RNF_20060901.doc b/Docs/SIL00205_RNF_20060901.doc
new file mode 100644 (file)
index 0000000..ac89801
Binary files /dev/null and b/Docs/SIL00205_RNF_20060901.doc differ
diff --git a/Docs/igx_to_2_6_15_1_diff.txt b/Docs/igx_to_2_6_15_1_diff.txt
new file mode 100644 (file)
index 0000000..909c4df
--- /dev/null
@@ -0,0 +1,415 @@
+26a27
+> #include <linux/moduleparam.h>
+29,48d29
+< 
+< #if LINUX26
+< 
+< #include <linux/moduleparam.h>
+< #define DEV_ERR(dev,format,arg...) dev_err(dev,format, ## arg)
+< #define USB_KILL_URB usb_kill_urb
+< 
+< #else /* !LINUX26 */
+< 
+< #ifdef CONFIG_USB_SERIAL_DEBUG
+<      static int debug = 1;
+< #else
+<      static int debug;
+< #endif
+< 
+< #define DEV_ERR(dev,format,arg...)  err(format, ## arg)
+< #define USB_KILL_URB  usb_unlink_urb
+< 
+< #endif /* LINUX26 */
+< 
+54,55c35,36
+< #define DRIVER_VERSION "v0.10"
+< #define DRIVER_DESC "Silicon Labs CP2101/CP2102/CP2103 RS232 serial adaptor driver"
+---
+> #define DRIVER_VERSION "v0.05"
+> #define DRIVER_DESC "Silicon Labs CP2101/CP2102 RS232 serial adaptor driver"
+60c41
+< static int   cp2101_open(struct usb_serial_port*, struct file*);
+---
+> static int cp2101_open(struct usb_serial_port*, struct file*);
+64a46,48
+> static int cp2101_tiocmget (struct usb_serial_port *, struct file *);
+> static int cp2101_tiocmset (struct usb_serial_port *, struct file *,
+>              unsigned int, unsigned int);
+66c50
+< static int   cp2101_startup (struct usb_serial *);
+---
+> static int cp2101_startup (struct usb_serial *);
+68,70c52
+< static int  cp2101_ioctl (struct usb_serial_port *port, struct file *file, unsigned int cmd, unsigned long arg);
+< static int   cp2101_tiocmget (struct usb_serial_port *, struct file *);
+< static int   cp2101_tiocmset (struct usb_serial_port *, struct file *, unsigned int, unsigned int);
+---
+> 
+74a57
+>      { USB_DEVICE(0x0FCF, 0x1003) }, /* Dynastream ANT development board */
+76a60,61
+>      { USB_DEVICE(0x10C4, 0x80F6) }, /* Suunto sports instrument */
+>      { USB_DEVICE(0x10A6, 0xAA26) }, /* Knock-off DCU-11 cable */
+77a63
+>      { USB_DEVICE(0x16D6, 0x0001) }, /* Jablotron serial interface */
+83d68
+< #if LINUX26
+86c71
+<      .name           = "CP2101",
+---
+>      .name           = "cp2101",
+91,92d75
+< #define USB_SUBMIT_URB_ATOMIC(_x_) usb_submit_urb(_x_ , GFP_ATOMIC)
+< #define USB_SUBMIT_URB_KERNEL(_x_) usb_submit_urb(_x_ , GFP_KERNEL)
+94,103c77,82
+< #else  /* LINUX26 */
+< 
+< #define USB_SUBMIT_URB_ATOMIC(_x_) usb_submit_urb(_x_)
+< #define USB_SUBMIT_URB_KERNEL(_x_) usb_submit_urb(_x_)
+< #endif
+< 
+< static struct usb_serial_device_type cp2101_device = {
+<      .owner                          = THIS_MODULE,
+<      .name                           = "CP2101/CP2102/CP2103 USB to UART Bridge",
+<      .id_table                       = id_table,
+---
+> static struct usb_serial_driver cp2101_device = {
+>      .driver = {
+>              .owner =        THIS_MODULE,
+>              .name =         "cp2101",
+>      },
+>      .id_table               = id_table,
+107,111c86,89
+<      .num_ports                      = 1,
+<      .open                           = cp2101_open,
+<      .close                          = cp2101_close,
+<     .ioctl              = cp2101_ioctl,     /* GLA, Added backport */
+<      .break_ctl                      = cp2101_break_ctl,
+---
+>      .num_ports              = 1,
+>      .open                   = cp2101_open,
+>      .close                  = cp2101_close,
+>      .break_ctl              = cp2101_break_ctl,
+113,120c91,94
+<      .shutdown                       = cp2101_shutdown,
+< #if LINUX26
+<      .tiocmget                       = cp2101_tiocmget,
+<      .tiocmset                       = cp2101_tiocmset,
+<      .attach                         = cp2101_startup
+< #else
+<      .startup                        = cp2101_startup
+< #endif
+---
+>      .tiocmget               = cp2101_tiocmget,
+>      .tiocmset               = cp2101_tiocmset,
+>      .attach                 = cp2101_startup,
+>      .shutdown               = cp2101_shutdown,
+128,134c102,108
+< #define CP2101_UART                  0x00    /* Enable / Disable */
+< #define CP2101_BAUDRATE                      0x01    /* (BAUD_RATE_GEN_FREQ / baudrate) */
+< #define CP2101_BITS                          0x03    /* 0x(0)(databits)(parity)(stopbits) */
+< #define CP2101_BREAK                 0x05    /* On / Off */
+< #define CP2101_CONTROL                       0x07    /* Flow control line states */
+< #define CP2101_MODEMCTL                      0x13    /* Modem controls */
+< #define CP2101_CONFIG_6                      0x19    /* 6 bytes of config data ??? */
+---
+> #define CP2101_UART          0x00    /* Enable / Disable */
+> #define CP2101_BAUDRATE              0x01    /* (BAUD_RATE_GEN_FREQ / baudrate) */
+> #define CP2101_BITS          0x03    /* 0x(0)(databits)(parity)(stopbits) */
+> #define CP2101_BREAK         0x05    /* On / Off */
+> #define CP2101_CONTROL               0x07    /* Flow control line states */
+> #define CP2101_MODEMCTL              0x13    /* Modem controls */
+> #define CP2101_CONFIG_6              0x19    /* 6 bytes of config data ??? */
+137,138c111,112
+< #define UART_ENABLE                          0x0001
+< #define UART_DISABLE                 0x0000
+---
+> #define UART_ENABLE          0x0001
+> #define UART_DISABLE         0x0000
+141c115
+< #define BAUD_RATE_GEN_FREQ           0x384000
+---
+> #define BAUD_RATE_GEN_FREQ   0x384000
+144,161c118,135
+< #define BITS_DATA_MASK                       0x0f00
+< #define BITS_DATA_5                          0x0500
+< #define BITS_DATA_6                          0x0600
+< #define BITS_DATA_7                          0x0700
+< #define BITS_DATA_8                          0x0800
+< #define BITS_DATA_9                          0x0900
+< 
+< #define BITS_PARITY_MASK             0x00f0
+< #define BITS_PARITY_NONE             0x0000
+< #define BITS_PARITY_ODD                      0x0010
+< #define BITS_PARITY_EVEN             0x0020
+< #define BITS_PARITY_MARK             0x0030
+< #define BITS_PARITY_SPACE            0x0040
+< 
+< #define BITS_STOP_MASK                   0x000f
+< #define BITS_STOP_1                  0x0000
+< #define BITS_STOP_1_5                    0x0001
+< #define BITS_STOP_2                  0x0002
+---
+> #define BITS_DATA_MASK               0X0f00
+> #define BITS_DATA_5          0X0500
+> #define BITS_DATA_6          0X0600
+> #define BITS_DATA_7          0X0700
+> #define BITS_DATA_8          0X0800
+> #define BITS_DATA_9          0X0900
+> 
+> #define BITS_PARITY_MASK     0x00f0
+> #define BITS_PARITY_NONE     0x0000
+> #define BITS_PARITY_ODD              0x0010
+> #define BITS_PARITY_EVEN     0x0020
+> #define BITS_PARITY_MARK     0x0030
+> #define BITS_PARITY_SPACE    0x0040
+> 
+> #define BITS_STOP_MASK               0x000f
+> #define BITS_STOP_1          0x0000
+> #define BITS_STOP_1_5                0x0001
+> #define BITS_STOP_2          0x0002
+164,165c138,139
+< #define BREAK_ON                     0x0000
+< #define BREAK_OFF                    0x0001
+---
+> #define BREAK_ON             0x0000
+> #define BREAK_OFF            0x0001
+168,175c142,149
+< #define CONTROL_DTR                  0x0001
+< #define CONTROL_RTS                  0x0002
+< #define CONTROL_CTS                  0x0010
+< #define CONTROL_DSR                  0x0020
+< #define CONTROL_RING             0x0040
+< #define CONTROL_DCD                  0x0080
+< #define CONTROL_WRITE_DTR        0x0100
+< #define CONTROL_WRITE_RTS        0x0200
+---
+> #define CONTROL_DTR          0x0001
+> #define CONTROL_RTS          0x0002
+> #define CONTROL_CTS          0x0010
+> #define CONTROL_DSR          0x0020
+> #define CONTROL_RING         0x0040
+> #define CONTROL_DCD          0x0080
+> #define CONTROL_WRITE_DTR    0x0100
+> #define CONTROL_WRITE_RTS    0x0200
+198c172
+<              DEV_ERR(&port->dev,"%s - out of memory.\n", __FUNCTION__);
+---
+>              dev_err(&port->dev, "%s - out of memory.\n", __FUNCTION__);
+206,215c180,182
+<      result = usb_control_msg (
+<                     serial->dev,
+<                     usb_rcvctrlpipe (serial->dev, 0),
+<                                  request, 
+<                     REQTYPE_DEVICE_TO_HOST, 
+<                     0x0000,
+<                                  0, 
+<                     buf, 
+<                     size, 
+<                     300);
+---
+>      result = usb_control_msg (serial->dev,usb_rcvctrlpipe (serial->dev, 0),
+>                              request, REQTYPE_DEVICE_TO_HOST, 0x0000,
+>                              0, buf, size, 300);
+218c185,186
+<      for (i=0; i<length; i++) data[i] = le32_to_cpu(buf[i]);
+---
+>      for (i=0; i<length; i++)
+>              data[i] = le32_to_cpu(buf[i]);
+223c191
+<              DEV_ERR(&port->dev,"%s - Unable to send config request, "
+---
+>              dev_err(&port->dev, "%s - Unable to send config request, "
+250c218
+<              DEV_ERR(&port->dev,"%s - out of memory.\n",
+---
+>              dev_err(&port->dev, "%s - out of memory.\n",
+256c224,225
+<      for (i = 0; i < length; i++) buf[i] = cpu_to_le32(data[i]);
+---
+>      for (i = 0; i < length; i++)
+>              buf[i] = cpu_to_le32(data[i]);
+259,268c228,231
+<              result = usb_control_msg (
+<                     serial->dev,
+<                                  usb_sndctrlpipe(serial->dev, 0),
+<                                  request, 
+<                     REQTYPE_HOST_TO_DEVICE, 
+<                     0x0000,
+<                                  0, 
+<                     buf, 
+<                     size, 
+<                     300);
+---
+>              result = usb_control_msg (serial->dev,
+>                              usb_sndctrlpipe(serial->dev, 0),
+>                              request, REQTYPE_HOST_TO_DEVICE, 0x0000,
+>                              0, buf, size, 300);
+270,279c233,236
+<              result = usb_control_msg (
+<                     serial->dev,
+<                                  usb_sndctrlpipe(serial->dev, 0),
+<                                  request, 
+<                     REQTYPE_HOST_TO_DEVICE, 
+<                     data[0],
+<                                  0, 
+<                     NULL, 
+<                     0, 
+<                     300);
+---
+>              result = usb_control_msg (serial->dev,
+>                              usb_sndctrlpipe(serial->dev, 0),
+>                              request, REQTYPE_HOST_TO_DEVICE, data[0],
+>                              0, NULL, 0, 300);
+285c242
+<              DEV_ERR(&port->dev,"%s - Unable to send request, "
+---
+>              dev_err(&port->dev, "%s - Unable to send request, "
+292,301c249,252
+<      result = usb_control_msg (
+<                 serial->dev,
+<                          usb_sndctrlpipe(serial->dev, 0),
+<                          request,
+<                 REQTYPE_HOST_TO_DEVICE, 
+<                 data[0],
+<                          0, 
+<                 NULL, 
+<                 0, 
+<                 300);
+---
+>      result = usb_control_msg (serial->dev,
+>                      usb_sndctrlpipe(serial->dev, 0),
+>                      request, REQTYPE_HOST_TO_DEVICE, data[0],
+>                      0, NULL, 0, 300);
+324c275
+<              DEV_ERR(&port->dev, "%s - Unable to enable UART\n",
+---
+>              dev_err(&port->dev, "%s - Unable to enable UART\n",
+337c288
+<      result = USB_SUBMIT_URB_KERNEL(port->read_urb);
+---
+>      result = usb_submit_urb(port->read_urb, GFP_KERNEL);
+339c290
+<              DEV_ERR(&port->dev, "%s - failed resubmitting read urb, "
+---
+>              dev_err(&port->dev, "%s - failed resubmitting read urb, "
+359c310
+<      if (serial != NULL && serial->dev) {
+---
+>      if (serial->dev) {
+362c313
+<                      USB_KILL_URB(port->write_urb);
+---
+>                      usb_kill_urb(port->write_urb);
+364c315
+<                      USB_KILL_URB(port->read_urb);
+---
+>                      usb_kill_urb(port->read_urb);
+366,374d316
+< 
+< #if LINUX26
+<      kfree (usb_get_serial_port_data(port));
+<      usb_set_serial_port_data(port, NULL);
+< #else
+<      /*TODOGLA: port.private maybe?
+<        Nobody is using that at the moement in this driver*/
+< #endif
+< 
+383,384c325,326
+<      USB_KILL_URB(port->write_urb);
+<      USB_KILL_URB(port->read_urb);
+---
+>      usb_kill_urb(port->write_urb);
+>      usb_kill_urb(port->read_urb);
+615c557
+<                              DEV_ERR(&port->dev, "cp2101 driver does not "
+---
+>                              dev_err(&port->dev, "cp2101 driver does not "
+625c567
+<                              DEV_ERR(&port->dev, "Baud rate requested not "
+---
+>                              dev_err(&port->dev, "Baud rate requested not "
+656c598
+<                              DEV_ERR(&port->dev, "cp2101 driver does not "
+---
+>                              dev_err(&port->dev, "cp2101 driver does not "
+663c605
+<                      DEV_ERR(&port->dev,"Number of data bits requested "
+---
+>                      dev_err(&port->dev, "Number of data bits requested "
+680c622
+<                      DEV_ERR(&port->dev,"Parity mode not supported "
+---
+>                      dev_err(&port->dev, "Parity mode not supported "
+695c637
+<                      DEV_ERR(&port->dev,"Number of stop bits requested "
+---
+>                      dev_err(&port->dev, "Number of stop bits requested "
+789,827d730
+< static int cp2101_ioctl (struct usb_serial_port *port, struct file *file, unsigned int cmd, unsigned long arg)
+< {
+<      dbg("%s (%d) cmd = 0x%04x", __FUNCTION__, port->number, cmd);
+< 
+<      switch (cmd) {
+<              
+< #if !LINUX26
+<              case TIOCMGET:
+<             {
+<                 int result = cp2101_tiocmget(port, file);
+<                 if (copy_to_user(&arg, &result, sizeof(int)))
+<                              return -EFAULT; 
+<             }
+<             break;
+<             
+<              case TIOCMSET:
+<              case TIOCMBIS:
+< 
+<              case TIOCMBIC:
+<             {
+<                 int val = 0;
+<                 
+<                  if (copy_from_user(&val, &arg, sizeof(int)))
+<                          return -EFAULT;
+<             
+<                 if(cp2101_tiocmset(port, file, cmd==TIOCMBIC?0:val,  cmd==TIOCMBIC?val:0))
+<                     return -EFAULT;
+<             }
+<             break;
+< #endif
+< 
+<              default:
+<                      dbg("%s not supported = 0x%04x", __FUNCTION__, cmd);
+<                      break;
+<      }
+< 
+<      return -ENOIOCTLCMD;
+< }
+< 
+843d745
+< #if LINUX26
+845,847d746
+< #else
+<              cp2101_cleanup(&serial->port[i]);
+< #endif
+859,860c758
+< #if LINUX26
+<      retval = usb_register(&cp2101_driver);
+---
+>      retval = usb_register(&cp2101_driver);
+866c764
+< #endif
+---
+> 
+874d771
+< #if LINUX26
+876d772
+< #endif
+883a780
+> MODULE_VERSION(DRIVER_VERSION);
+886,887d782
+< #if LINUX26
+< MODULE_VERSION(DRIVER_VERSION);
+889,891d783
+< #else
+< MODULE_PARM(debug, "i");
+< #endif
diff --git a/Makefile b/Makefile
new file mode 100644 (file)
index 0000000..5d5dbb8
--- /dev/null
+++ b/Makefile
@@ -0,0 +1,10 @@
+# CP2101 Makefile
+
+ifeq ("$(src)", "")
+       include Makefile.config
+       include Makefile$(KVER1)$(KVER2)
+else
+       include $(src)/Makefile.config
+       include $(src)/Makefile$(KVER1)$(KVER2)
+endif
+
diff --git a/Makefile.go b/Makefile.go
new file mode 100644 (file)
index 0000000..407680c
--- /dev/null
@@ -0,0 +1,46 @@
+#
+# CP2101/CP2102/CP2103 USB to Serial Bridge Makefile
+#
+# (c) 2005-2006 Silicon Laboratories
+#
+# all       - builds the modules, same as modules
+# modules   - builds kernel module
+# install   - installs driver
+# clean     - removes all object code
+# distclean - remove everything resulting from building
+# mrproper  - remove emacs debris
+#
+
+OBJS = cp2101.o
+
+SRC = cp2102.c
+
+
+include ./Makefile.config
+
+KVER=$(KVER1).$(KVER2).$(KVER3)
+MODULE=cp2101$(EXT)
+MODULES_DIR=$(INSTALL_PREFIX)/lib/modules
+MODULES_VER_DIR=$(MODULES_DIR)/$(KVER)
+
+# Rules
+
+all:   modules
+
+clean:
+       rm -f *.o .*.o.flags
+       rm -f *.ko .*.o.cmd .*.ko.cmd *.mod.c
+       rm -rf .tmp_versions
+
+distclean: clean mrproper
+       rm -f Makefile.config
+
+install:
+       ./installmod $(MODULE) $(MODULES_VER_DIR) $(MODULES_DIR)
+
+mrproper:
+       rm -f *~
+       rm -f Makefile.bak
+
+modules:
+       make -C $(LINUX_KERNEL) SUBDIRS="`pwd`" modules
diff --git a/Makefile24 b/Makefile24
new file mode 100644 (file)
index 0000000..4a19ad3
--- /dev/null
@@ -0,0 +1,7 @@
+#
+
+EXTRA_CFLAGS += -I$(LINUX_KERNEL)/drivers/usb/serial
+
+obj-m += cp2101.o
+
+include $(TOPDIR)/Rules.make
diff --git a/Makefile26 b/Makefile26
new file mode 100644 (file)
index 0000000..2456377
--- /dev/null
@@ -0,0 +1,7 @@
+# CP2101/CP2102/CP2103 2.6 makefile
+
+EXTRA_CFLAGS += -I$(LINUX_INCLUDE) -I$(LINUX_KERNEL)/drivers/usb/serial -DLINUX26
+
+obj-m := cp2101.o
+
+cp2101-objs := $(OBJS)
diff --git a/Modules.symvers b/Modules.symvers
new file mode 100644 (file)
index 0000000..e69de29
diff --git a/Rules.make b/Rules.make
new file mode 100644 (file)
index 0000000..c855f39
--- /dev/null
@@ -0,0 +1,73 @@
+# -*-makefile-*-
+#
+# This file is a helper make file that makes building easier. It is meant 
+# to be generic and is designed to be recycled by other drivers. The 
+# comments should be clear enough. It partly comes from Linux Makefile, 
+# and needs GNU make. 
+
+# TOPDIR is declared by the Makefile including this file.
+ifndef TOPDIR
+    TOPDIR = .
+endif
+
+# KERNELDIR can be speficied on the command line or environment
+#  this may assuems a symbolic link has been set to /usr/src/linux
+ifndef KERNELDIR
+    KERNELDIR = /usr/src/linux
+endif
+# The headers are taken from the kernel
+    INCLUDEDIR = $(KERNELDIR)/include
+
+# We need the configuration file, for CONFIG_SMP and possibly other stuff
+# (especiall for RISC platforms, where CFLAGS depends on the exact
+# processor being used).
+#ifeq ($(KERNELDIR)/.config,$(wildcard $(KERNELDIR))/.config)
+#   include $(KERNELDIR)/.config
+#else
+#   MESSAGE := $(shell echo "WARNING: no .config file in $(KERNELDIR)")
+#endif
+
+# ARCH can be speficed on the comdline or env. too, and defaults to this arch
+# Unfortunately, we can't easily extract if from kernel configuration
+# (well, we could look athe asm- symlink... don't know if worth the effort)
+ifndef ARCH
+  ARCH := $(shell uname -m | sed -e s/i.86/i386/ -e s/sun4u/sparc64/ \
+        -e s/arm.*/arm/ -e s/sa110/arm/)
+endif
+
+# This is useful if cross-compiling. Taken from kernel Makefile (CC changed)
+AS      =$(CROSS_COMPILE)as
+LD      =$(CROSS_COMPILE)ld
+CC      =$(CROSS_COMPILE)gcc
+CPP     =$(CC) -E
+AR      =$(CROSS_COMPILE)ar
+NM      =$(CROSS_COMPILE)nm
+STRIP   =$(CROSS_COMPILE)strip
+OBJCOPY =$(CROSS_COMPILE)objcopy
+OBJDUMP =$(CROSS_COMPILE)objdump
+
+# The platform-specific Makefiles include portability nightmares.
+# Some platforms, though, don't have one, so check for existence first
+ARCHMAKEFILE = $(TOPDIR)/Makefile.$(ARCH)
+ifeq ($(ARCHMAKEFILE),$(wildcard $(ARCHMAKEFILE)))
+  include $(ARCHMAKEFILE)
+endif
+
+# CFLAGS: all assignments to CFLAGS are inclremental, so you can specify
+# the initial flags on the command line or environment, if needed.
+
+    CFLAGS +=  -Wall -D__KERNEL__ -DMODULE -I$(INCLUDEDIR)
+
+ifdef CONFIG_SMP
+    CFLAGS += -D__SMP__ -DSMP
+endif
+
+# Prepend modversions.h if we're running with versioning.
+ifdef CONFIG_MODVERSIONS
+    CFLAGS += -DMODVERSIONS -include $(KERNELDIR)/include/linux/modversions.h
+endif
+
+#Install dir
+VERSIONFILE = $(INCLUDEDIR)/linux/version.h
+VERSION     = $(shell awk -F\" '/REL/ {print $$2}' $(VERSIONFILE))
+INSTALLDIR = /lib/modules/$(VERSION)/misc
diff --git a/configure b/configure
new file mode 100755 (executable)
index 0000000..1d20a18
--- /dev/null
+++ b/configure
@@ -0,0 +1,118 @@
+#!/bin/bash
+
+function usage()
+{
+    echo "Usage: $0 [option ...]"
+    echo ""
+    echo "Where 'option' can be one of the following:"
+    echo "  -kinc <path>                 Kernel header files."
+    echo "  -kpath <path>                Kernel sources."
+    echo "  -kver <version>              Kernel version."
+    echo "  -p <install folder>          Prefix for installing the kernel module."
+}
+
+this_dir=`pwd`
+
+ARCH=""
+TARGET="linux"
+LINUX_KERNEL="/lib/modules/`uname -r`/build"
+KVER=""
+LIBPATH=""
+INSTALL_PREFIX=""
+CONFIG_FILE="Makefile.config"
+
+
+while (($# > 0)) ; do
+    if [ "$1" == "-help" ] || [ "$1" == "-h" ] ; then
+        usage
+       exit 0   
+    elif [ "$1" == "-kinc" ] ; then
+       if [ "$2" == "" ] ; then
+           usage
+           exit 1
+       fi
+        LINUX_INCLUDE="$2"
+       shift 2
+    elif [ "$1" == "-kpath" ] ; then
+       if [ "$2" == "" ] ; then
+           usage
+           exit 1
+       fi
+        LINUX_KERNEL="$2"
+       shift 2
+    elif [ "$1" == "-kver" ] ; then
+       if [ "$2" == "" ] ; then
+           usage
+           exit 1
+       fi
+       KVER="$2"
+       shift 2
+    elif [ "$1" == "-p" ] ; then
+       if [ "$2" == "" ] ; then
+           usage
+           exit 1
+       fi
+        INSTALL_PREFIX="$2"
+       shift 2
+    else
+        echo "ERROR: Unknown option $1"
+        exit 1
+    fi
+done
+
+if [ "$LINUX_INCLUDE" == "" ] ; then
+    LINUX_INCLUDE="$LINUX_KERNEL/include"
+fi
+
+if [ ! -d "$LINUX_KERNEL" ] ; then
+       echo "ERROR: $LINUX_KERNEL was not found."
+       exit 1
+fi
+
+if [ ! -d "$LINUX_INCLUDE" ] ; then
+       echo "ERROR: $LINUX_INCLUDE was not found."
+       exit 1
+fi
+
+if [ "$KVER" == "" ] ; then
+    if [ -f "$LINUX_INCLUDE/linux/version.h" ] ; then
+       KVER=`grep UTS_RELEASE $LINUX_INCLUDE/linux/version.h | awk -- '{ if (FNR==1) { print $3 } }'`
+       KVER=`echo $KVER | sed -e 's/"//g'`
+    else
+       echo "ERROR: $LINUX_INCLUDE/linux/version.h was not found. Configured kernel?"
+       exit 1
+    fi
+fi
+
+KVER1=`echo $KVER | awk -F . -- '{ print $1 }'`
+KVER2=`echo $KVER | awk -F . -- '{ print $2 }'`
+KVER3=`echo $KVER | sed -e "s/$KVER1\\.$KVER2\\.//g"`
+
+case $KVER2 in
+    4)
+       makefile="Makefile24"
+       EXT=".o"
+       ;;
+    6)
+       makefile="Makefile26"
+       EXT=".ko"
+       ;;
+esac
+
+echo "Kernel version        : $KVER1.$KVER2.$KVER3"
+echo "Module extension      : $EXT"
+echo "Kernel directory      : $LINUX_KERNEL"
+echo "Include directory     : $LINUX_INCLUDE"
+echo "Module install prefix : $INSTALL_PREFIX"
+
+
+rm -f $CONFIG_FILE
+echo "# Makefile.config" >>$CONFIG_FILE
+echo "# Automatically generated" >>$CONFIG_FILE
+echo "KVER1=$KVER1" >>$CONFIG_FILE
+echo "KVER2=$KVER2" >>$CONFIG_FILE
+echo "KVER3=$KVER3" >>$CONFIG_FILE
+echo "EXT=$EXT" >>$CONFIG_FILE
+echo "LINUX_KERNEL=$LINUX_KERNEL" >>$CONFIG_FILE
+echo "LINUX_INCLUDE=$LINUX_INCLUDE" >>$CONFIG_FILE
+echo "INSTALL_PREFIX=$INSTALL_PREFIX" >>$CONFIG_FILE
diff --git a/cp2101.c b/cp2101.c
new file mode 100644 (file)
index 0000000..6664cb3
--- /dev/null
+++ b/cp2101.c
@@ -0,0 +1,915 @@
+/*
+ * Silicon Laboratories CP2101/CP2102/CP2103 USB to RS232 serial adaptor driver
+ *
+ * Copyright (C) 2005 Craig Shelley (craig@microtron.org.uk)
+ *
+ *     This program is free software; you can redistribute it and/or
+ *     modify it under the terms of the GNU General Public License version
+ *     2 as published by the Free Software Foundation.
+ *
+ * Support to set flow control line levels using TIOCMGET and TIOCMSET
+ * thanks to Karl Hiramoto karl@hiramoto.org. RTSCTS hardware flow
+ * control thanks to Munir Nassar nassarmu@real-time.com
+ *
+ * Outstanding Issues:
+ *  Buffers are not flushed when the port is opened.
+ *  Multiple calls to write() may fail with "Resource temporarily unavailable"
+ *
+ */
+
+#include <linux/config.h>
+#include <linux/kernel.h>
+#include <linux/errno.h>
+#include <linux/slab.h>
+#include <linux/tty.h>
+#include <linux/tty_flip.h>
+#include <linux/module.h>
+#include <linux/usb.h>
+#include <linux/version.h>
+#include <asm/uaccess.h>
+
+#ifndef KERNEL_VERSION
+#define KERNEL_VERSION(a,b,c) ((a)*65536 + (b)*256 + (c))
+#endif
+
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
+#ifdef LINUX26
+#undef LINUX26
+#endif
+#define LINUX26
+#endif
+
+#ifdef LINUX26
+
+#include <linux/moduleparam.h>
+#define DEV_ERR(dev,format,arg...) dev_err(dev,format, ## arg)
+#define USB_KILL_URB usb_kill_urb
+
+#else /* !LINUX26 */
+
+#ifdef CONFIG_USB_SERIAL_DEBUG
+       static int debug = 1;
+#else
+       static int debug;
+#endif
+
+#define DEV_ERR(dev,format,arg...)  err(format, ## arg)
+#define USB_KILL_URB  usb_unlink_urb
+
+#endif /* LINUX26 */
+
+#include "usb-serial.h"
+
+/*
+ * Version Information
+ * RJM: updated to 0.11 for 2.6.15 and later kernels
+ */
+#define DRIVER_VERSION "v0.11"
+#define DRIVER_DESC "Silicon Labs CP2101/CP2102/CP2103 RS232 serial adaptor driver"
+
+/*
+ * Function Prototypes
+ */
+static int     cp2101_open(struct usb_serial_port*, struct file*);
+static void cp2101_cleanup(struct usb_serial_port*);
+static void cp2101_close(struct usb_serial_port*, struct file*);
+static void cp2101_get_termios(struct usb_serial_port*);
+static void cp2101_set_termios(struct usb_serial_port*, struct termios*);
+static void cp2101_break_ctl(struct usb_serial_port*, int);
+static int     cp2101_startup (struct usb_serial *);
+static void cp2101_shutdown(struct usb_serial*);
+static int  cp2101_ioctl (struct usb_serial_port *port, struct file *file, unsigned int cmd, unsigned long arg);
+static int     cp2101_tiocmget (struct usb_serial_port *, struct file *);
+static int     cp2101_tiocmset (struct usb_serial_port *, struct file *, unsigned int, unsigned int);
+
+static int debug;
+
+static struct usb_device_id id_table [] = {
+       { USB_DEVICE(0x10C4, 0xEA60) }, /* Silicon Labs factory default */
+       { USB_DEVICE(0x10C4, 0x80CA) }, /* Degree Controls Inc */
+       { USB_DEVICE(0x10AB, 0x10C5) }, /* Siemens MC60 Cable */
+       { } /* Terminating Entry */
+};
+
+MODULE_DEVICE_TABLE (usb, id_table);
+
+#ifdef LINUX26
+static struct usb_driver cp2101_driver = {
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,15)
+       .owner          = THIS_MODULE,
+#endif
+       .name           = "CP2101",
+       .probe          = usb_serial_probe,
+       .disconnect     = usb_serial_disconnect,
+       .id_table       = id_table,
+};
+#define USB_SUBMIT_URB_ATOMIC(_x_) usb_submit_urb(_x_ , GFP_ATOMIC)
+#define USB_SUBMIT_URB_KERNEL(_x_) usb_submit_urb(_x_ , GFP_KERNEL)
+
+#else  /* LINUX26 */
+
+#define USB_SUBMIT_URB_ATOMIC(_x_) usb_submit_urb(_x_)
+#define USB_SUBMIT_URB_KERNEL(_x_) usb_submit_urb(_x_)
+#endif
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,15)
+static struct usb_serial_driver cp2101_device = {
+       .driver = {
+               .owner =        THIS_MODULE,
+               .name =         "cp2101",
+       },
+#else
+static struct usb_serial_device_type cp2101_device = {
+       .owner                          = THIS_MODULE,
+       .name                           = "CP2101/CP2102/CP2103 USB to UART Bridge",
+#endif
+       .id_table                       = id_table,
+       .num_interrupt_in       = 0,
+       .num_bulk_in            = 0,
+       .num_bulk_out           = 0,
+       .num_ports                      = 1,
+       .open                           = cp2101_open,
+       .close                          = cp2101_close,
+       .ioctl                          = cp2101_ioctl,     /* GLA, Added backport */
+       .break_ctl                      = cp2101_break_ctl,
+       .set_termios                    = cp2101_set_termios,
+#ifdef LINUX26
+       .tiocmget                       = cp2101_tiocmget,
+       .tiocmset                       = cp2101_tiocmset,
+       .attach                         = cp2101_startup,
+#else
+       .startup                        = cp2101_startup,
+#endif
+       .shutdown                       = cp2101_shutdown
+};
+
+/* Config request types */
+#define REQTYPE_HOST_TO_DEVICE 0x41
+#define REQTYPE_DEVICE_TO_HOST 0xc1
+
+/* Config SET requests. To GET, add 1 to the request number */
+#define CP2101_UART                    0x00    /* Enable / Disable */
+#define CP2101_BAUDRATE                        0x01    /* (BAUD_RATE_GEN_FREQ / baudrate) */
+#define CP2101_BITS                            0x03    /* 0x(0)(databits)(parity)(stopbits) */
+#define CP2101_BREAK                   0x05    /* On / Off */
+#define CP2101_CONTROL                 0x07    /* Flow control line states */
+#define CP2101_MODEMCTL                        0x13    /* Modem controls */
+#define CP2101_CONFIG_6                        0x19    /* 6 bytes of config data ??? */
+
+/* CP2101_UART */
+#define UART_ENABLE                            0x0001
+#define UART_DISABLE                   0x0000
+
+/* CP2101_BAUDRATE */
+#define BAUD_RATE_GEN_FREQ             0x384000
+
+/* CP2101_BITS */
+#define BITS_DATA_MASK                 0x0f00
+#define BITS_DATA_5                            0x0500
+#define BITS_DATA_6                            0x0600
+#define BITS_DATA_7                            0x0700
+#define BITS_DATA_8                            0x0800
+#define BITS_DATA_9                            0x0900
+
+#define BITS_PARITY_MASK               0x00f0
+#define BITS_PARITY_NONE               0x0000
+#define BITS_PARITY_ODD                        0x0010
+#define BITS_PARITY_EVEN               0x0020
+#define BITS_PARITY_MARK               0x0030
+#define BITS_PARITY_SPACE              0x0040
+
+#define BITS_STOP_MASK             0x000f
+#define BITS_STOP_1                    0x0000
+#define BITS_STOP_1_5              0x0001
+#define BITS_STOP_2                    0x0002
+
+/* CP2101_BREAK */
+#define BREAK_ON                       0x0000
+#define BREAK_OFF                      0x0001
+
+/* CP2101_CONTROL */
+#define CONTROL_DTR                    0x0001
+#define CONTROL_RTS                    0x0002
+#define CONTROL_CTS                    0x0010
+#define CONTROL_DSR                    0x0020
+#define CONTROL_RING               0x0040
+#define CONTROL_DCD                    0x0080
+#define CONTROL_WRITE_DTR          0x0100
+#define CONTROL_WRITE_RTS          0x0200
+
+/*
+ * cp2101_get_config
+ * Reads from the CP2101 configuration registers
+ * 'size' is specified in bytes.
+ * 'data' is a pointer to a pre-allocated array of integers large
+ * enough to hold 'size' bytes (with 4 bytes to each integer)
+ */
+static int cp2101_get_config(struct usb_serial_port* port, u8 request,
+               unsigned int *data, int size)
+{
+       struct usb_serial *serial = port->serial;
+       u32 *buf;
+       int result, i, length;
+
+       /* Number of integers required to contain the array */
+       length = (((size - 1) | 3) + 1)/4;
+
+       buf = kmalloc (length * sizeof(u32), GFP_KERNEL);
+       memset(buf, 0, length * sizeof(u32));
+
+       if (!buf) {
+               DEV_ERR(&port->dev,"%s - out of memory.\n", __FUNCTION__);
+               return -ENOMEM;
+       }
+
+       /* For get requests, the request number must be incremented */
+       request++;
+
+       /* Issue the request, attempting to read 'size' bytes */
+       result = usb_control_msg (
+                    serial->dev,
+                    usb_rcvctrlpipe (serial->dev, 0),
+                                   request, 
+                    REQTYPE_DEVICE_TO_HOST, 
+                    0x0000,
+                                   0, 
+                    buf, 
+                    size, 
+                    300);
+
+       /* Convert data into an array of integers */
+       for (i=0; i<length; i++) data[i] = le32_to_cpu(buf[i]);
+
+       kfree(buf);
+
+       if (result != size) {
+               DEV_ERR(&port->dev,"%s - Unable to send config request, "
+                               "request=0x%x size=%d result=%d\n",
+                               __FUNCTION__, request, size, result);
+               return -EPROTO;
+       }
+
+       return 0;
+}
+
+/*
+ * cp2101_set_config
+ * Writes to the CP2101 configuration registers
+ * Values less than 16 bits wide are sent directly
+ * 'size' is specified in bytes.
+ */
+static int cp2101_set_config(struct usb_serial_port* port, u8 request,
+               unsigned int *data, int size)
+{
+       struct usb_serial *serial = port->serial;
+       u32 *buf;
+       int result, i, length;
+
+       /* Number of integers required to contain the array */
+       length = (((size - 1) | 3) + 1)/4;
+
+       buf = kmalloc(length * sizeof(u32), GFP_KERNEL);
+       if (!buf) {
+               DEV_ERR(&port->dev,"%s - out of memory.\n",
+                               __FUNCTION__);
+               return -ENOMEM;
+       }
+
+       /* Array of integers into bytes */
+       for (i = 0; i < length; i++) buf[i] = cpu_to_le32(data[i]);
+
+       if (size > 2) {
+               result = usb_control_msg (
+                    serial->dev,
+                                   usb_sndctrlpipe(serial->dev, 0),
+                                   request, 
+                    REQTYPE_HOST_TO_DEVICE, 
+                    0x0000,
+                                   0, 
+                    buf, 
+                    size, 
+                    300);
+       } else {
+               result = usb_control_msg (
+                    serial->dev,
+                                   usb_sndctrlpipe(serial->dev, 0),
+                                   request, 
+                    REQTYPE_HOST_TO_DEVICE, 
+                    data[0],
+                                   0, 
+                    NULL, 
+                    0, 
+                    300);
+       }
+
+       kfree(buf);
+
+       if ((size > 2 && result != size) || result < 0) {
+               DEV_ERR(&port->dev,"%s - Unable to send request, "
+                               "request=0x%x size=%d result=%d\n",
+                               __FUNCTION__, request, size, result);
+               return -EPROTO;
+       }
+
+       /* Single data value */
+       result = usb_control_msg (
+                serial->dev,
+                           usb_sndctrlpipe(serial->dev, 0),
+                           request,
+                REQTYPE_HOST_TO_DEVICE, 
+                data[0],
+                           0, 
+                NULL, 
+                0, 
+                300);
+       return 0;
+}
+
+/*
+ * cp2101_set_config_single
+ * Convenience function for calling cp2101_set_config on single data values
+ * without requiring an integer pointer
+ */
+static inline int cp2101_set_config_single(struct usb_serial_port* port,
+               u8 request, unsigned int data)
+{
+       return cp2101_set_config(port, request, &data, 2);
+}
+
+static int cp2101_open (struct usb_serial_port *port, struct file *filp)
+{
+       struct usb_serial *serial = port->serial;
+       int result;
+
+       dbg("%s - port %d", __FUNCTION__, port->number);
+
+       if (cp2101_set_config_single(port, CP2101_UART, UART_ENABLE)) {
+               DEV_ERR(&port->dev, "%s - Unable to enable UART\n",
+                               __FUNCTION__);
+               return -EPROTO;
+       }
+
+       /* Start reading from the device */
+       usb_fill_bulk_urb (port->read_urb, serial->dev,
+                       usb_rcvbulkpipe(serial->dev,
+                       port->bulk_in_endpointAddress),
+                       port->read_urb->transfer_buffer,
+                       port->read_urb->transfer_buffer_length,
+                       serial->type->read_bulk_callback,
+                       port);
+       result = USB_SUBMIT_URB_KERNEL(port->read_urb);
+       if (result) {
+               DEV_ERR(&port->dev, "%s - failed resubmitting read urb, "
+                               "error %d\n", __FUNCTION__, result);
+               return result;
+       }
+
+       /* Configure the termios structure */
+       cp2101_get_termios(port);
+
+       /* Set the DTR and RTS pins low */
+       cp2101_tiocmset(port, NULL, TIOCM_DTR | TIOCM_RTS, 0);
+
+       return 0;
+}
+
+static void cp2101_cleanup (struct usb_serial_port *port)
+{
+       struct usb_serial *serial = port->serial;
+
+       dbg("%s - port %d", __FUNCTION__, port->number);
+
+       if (serial != NULL && serial->dev) {
+               /* shutdown any bulk reads that might be going on */
+               if (serial->num_bulk_out)
+                       USB_KILL_URB(port->write_urb);
+               if (serial->num_bulk_in)
+                       USB_KILL_URB(port->read_urb);
+       }
+
+#ifdef LINUX26
+       kfree (usb_get_serial_port_data(port));
+       usb_set_serial_port_data(port, NULL);
+#else
+       /*TODOGLA: port.private maybe?
+         Nobody is using that at the moement in this driver*/
+#endif
+
+}
+
+static void cp2101_close (struct usb_serial_port *port, struct file * filp)
+{
+       dbg("%s - port %d", __FUNCTION__, port->number);
+
+       /* shutdown our urbs */
+       dbg("%s - shutting down urbs", __FUNCTION__);
+       USB_KILL_URB(port->write_urb);
+       USB_KILL_URB(port->read_urb);
+
+       cp2101_set_config_single(port, CP2101_UART, UART_DISABLE);
+}
+
+/*
+ * cp2101_get_termios
+ * Reads the baud rate, data bits, parity, stop bits and flow control mode
+ * from the device, corrects any unsupported values, and configures the
+ * termios structure to reflect the state of the device
+ */
+static void cp2101_get_termios (struct usb_serial_port *port)
+{
+       unsigned int cflag, modem_ctl[4];
+       int baud;
+       int bits;
+
+       dbg("%s - port %d", __FUNCTION__, port->number);
+
+       if ((!port->tty) || (!port->tty->termios)) {
+               dbg("%s - no tty structures", __FUNCTION__);
+               return;
+       }
+       cflag = port->tty->termios->c_cflag;
+
+       cp2101_get_config(port, CP2101_BAUDRATE, &baud, 2);
+       /* Convert to baudrate */
+       if (baud)
+               baud = BAUD_RATE_GEN_FREQ / baud;
+
+       dbg("%s - baud rate = %d", __FUNCTION__, baud);
+       cflag &= ~CBAUD;
+       switch (baud) {
+               /*
+                * The baud rates which are commented out below
+                * appear to be supported by the device
+                * but are non-standard
+                */
+               case 600:       cflag |= B600;          break;
+               case 1200:      cflag |= B1200;         break;
+               case 1800:      cflag |= B1800;         break;
+               case 2400:      cflag |= B2400;         break;
+               case 4800:      cflag |= B4800;         break;
+               /*case 7200:    cflag |= B7200;         break;*/
+               case 9600:      cflag |= B9600;         break;
+               /*case 14400:   cflag |= B14400;        break;*/
+               case 19200:     cflag |= B19200;        break;
+               /*case 28800:   cflag |= B28800;        break;*/
+               case 38400:     cflag |= B38400;        break;
+               /*case 55854:   cflag |= B55054;        break;*/
+               case 57600:     cflag |= B57600;        break;
+               case 115200:    cflag |= B115200;       break;
+               /*case 127117:  cflag |= B127117;       break;*/
+               case 230400:    cflag |= B230400;       break;
+               case 460800:    cflag |= B460800;       break;
+               case 921600:    cflag |= B921600;       break;
+               /*case 3686400: cflag |= B3686400;      break;*/
+               default:
+                       dbg("%s - Baud rate is not supported, "
+                                       "using 9600 baud", __FUNCTION__);
+                       cflag |= B9600;
+                       cp2101_set_config_single(port, CP2101_BAUDRATE,
+                                       (BAUD_RATE_GEN_FREQ/9600));
+                       break;
+       }
+
+       cp2101_get_config(port, CP2101_BITS, &bits, 2);
+       cflag &= ~CSIZE;
+       switch(bits & BITS_DATA_MASK) {
+               case BITS_DATA_5:
+                       dbg("%s - data bits = 5", __FUNCTION__);
+                       cflag |= CS5;
+                       break;
+               case BITS_DATA_6:
+                       dbg("%s - data bits = 6", __FUNCTION__);
+                       cflag |= CS6;
+                       break;
+               case BITS_DATA_7:
+                       dbg("%s - data bits = 7", __FUNCTION__);
+                       cflag |= CS7;
+                       break;
+               case BITS_DATA_8:
+                       dbg("%s - data bits = 8", __FUNCTION__);
+                       cflag |= CS8;
+                       break;
+               case BITS_DATA_9:
+                       dbg("%s - data bits = 9 (not supported, "
+                                       "using 8 data bits)", __FUNCTION__);
+                       cflag |= CS8;
+                       bits &= ~BITS_DATA_MASK;
+                       bits |= BITS_DATA_8;
+                       cp2101_set_config(port, CP2101_BITS, &bits, 2);
+                       break;
+               default:
+                       dbg("%s - Unknown number of data bits, "
+                                       "using 8", __FUNCTION__);
+                       cflag |= CS8;
+                       bits &= ~BITS_DATA_MASK;
+                       bits |= BITS_DATA_8;
+                       cp2101_set_config(port, CP2101_BITS, &bits, 2);
+                       break;
+       }
+
+       switch(bits & BITS_PARITY_MASK) {
+               case BITS_PARITY_NONE:
+                       dbg("%s - parity = NONE", __FUNCTION__);
+                       cflag &= ~PARENB;
+                       break;
+               case BITS_PARITY_ODD:
+                       dbg("%s - parity = ODD", __FUNCTION__);
+                       cflag |= (PARENB|PARODD);
+                       break;
+               case BITS_PARITY_EVEN:
+                       dbg("%s - parity = EVEN", __FUNCTION__);
+                       cflag &= ~PARODD;
+                       cflag |= PARENB;
+                       break;
+               case BITS_PARITY_MARK:
+                       dbg("%s - parity = MARK (not supported, "
+                                       "disabling parity)", __FUNCTION__);
+                       cflag &= ~PARENB;
+                       bits &= ~BITS_PARITY_MASK;
+                       cp2101_set_config(port, CP2101_BITS, &bits, 2);
+                       break;
+               case BITS_PARITY_SPACE:
+                       dbg("%s - parity = SPACE (not supported, "
+                                       "disabling parity)", __FUNCTION__);
+                       cflag &= ~PARENB;
+                       bits &= ~BITS_PARITY_MASK;
+                       cp2101_set_config(port, CP2101_BITS, &bits, 2);
+                       break;
+               default:
+                       dbg("%s - Unknown parity mode, "
+                                       "disabling parity", __FUNCTION__);
+                       cflag &= ~PARENB;
+                       bits &= ~BITS_PARITY_MASK;
+                       cp2101_set_config(port, CP2101_BITS, &bits, 2);
+                       break;
+       }
+
+       cflag &= ~CSTOPB;
+       switch(bits & BITS_STOP_MASK) {
+               case BITS_STOP_1:
+                       dbg("%s - stop bits = 1", __FUNCTION__);
+                       break;
+               case BITS_STOP_1_5:
+                       dbg("%s - stop bits = 1.5 (not supported, "
+                                       "using 1 stop bit)", __FUNCTION__);
+                       bits &= ~BITS_STOP_MASK;
+                       cp2101_set_config(port, CP2101_BITS, &bits, 2);
+                       break;
+               case BITS_STOP_2:
+                       dbg("%s - stop bits = 2", __FUNCTION__);
+                       cflag |= CSTOPB;
+                       break;
+               default:
+                       dbg("%s - Unknown number of stop bits, "
+                                       "using 1 stop bit", __FUNCTION__);
+                       bits &= ~BITS_STOP_MASK;
+                       cp2101_set_config(port, CP2101_BITS, &bits, 2);
+                       break;
+       }
+
+       cp2101_get_config(port, CP2101_MODEMCTL, modem_ctl, 16);
+       if (modem_ctl[0] & 0x0008) {
+               dbg("%s - flow control = CRTSCTS", __FUNCTION__);
+               cflag |= CRTSCTS;
+       } else {
+               dbg("%s - flow control = NONE", __FUNCTION__);
+               cflag &= ~CRTSCTS;
+       }
+
+       port->tty->termios->c_cflag = cflag;
+}
+
+static void cp2101_set_termios (struct usb_serial_port *port,
+               struct termios *old_termios)
+{
+       unsigned int cflag, old_cflag=0;
+       int baud=0, bits;
+       unsigned int modem_ctl[4];
+
+       dbg("%s - port %d", __FUNCTION__, port->number);
+
+       if ((!port->tty) || (!port->tty->termios)) {
+               dbg("%s - no tty structures", __FUNCTION__);
+               return;
+       }
+       cflag = port->tty->termios->c_cflag;
+
+       /* Check that they really want us to change something */
+       if (old_termios) {
+               if ((cflag == old_termios->c_cflag) &&
+                               (RELEVANT_IFLAG(port->tty->termios->c_iflag)
+                               == RELEVANT_IFLAG(old_termios->c_iflag))) {
+                       dbg("%s - nothing to change...", __FUNCTION__);
+                       return;
+               }
+
+               old_cflag = old_termios->c_cflag;
+       }
+
+       /* If the baud rate is to be updated*/
+       if ((cflag & CBAUD) != (old_cflag & CBAUD)) {
+               switch (cflag & CBAUD) {
+                       /*
+                        * The baud rates which are commented out below
+                        * appear to be supported by the device
+                        * but are non-standard
+                        */
+                       case B0:        baud = 0;       break;
+                       case B600:      baud = 600;     break;
+                       case B1200:     baud = 1200;    break;
+                       case B1800:     baud = 1800;    break;
+                       case B2400:     baud = 2400;    break;
+                       case B4800:     baud = 4800;    break;
+                       /*case B7200:   baud = 7200;    break;*/
+                       case B9600:     baud = 9600;    break;
+                       /*ase B14400:   baud = 14400;   break;*/
+                       case B19200:    baud = 19200;   break;
+                       /*case B28800:  baud = 28800;   break;*/
+                       case B38400:    baud = 38400;   break;
+                       /*case B55854:  baud = 55054;   break;*/
+                       case B57600:    baud = 57600;   break;
+                       case B115200:   baud = 115200;  break;
+                       /*case B127117: baud = 127117;  break;*/
+                       case B230400:   baud = 230400;  break;
+                       case B460800:   baud = 460800;  break;
+                       case B921600:   baud = 921600;  break;
+                       /*case B3686400:        baud = 3686400; break;*/
+                       default:
+                               DEV_ERR(&port->dev, "cp2101 driver does not "
+                                       "support the baudrate requested\n");
+                               break;
+               }
+
+               if (baud) {
+                       dbg("%s - Setting baud rate to %d baud", __FUNCTION__,
+                                       baud);
+                       if (cp2101_set_config_single(port, CP2101_BAUDRATE,
+                                               (BAUD_RATE_GEN_FREQ / baud)))
+                               DEV_ERR(&port->dev, "Baud rate requested not "
+                                               "supported by device\n");
+               }
+       }
+
+       /* If the number of data bits is to be updated */
+       if ((cflag & CSIZE) != (old_cflag & CSIZE)) {
+               cp2101_get_config(port, CP2101_BITS, &bits, 2);
+               bits &= ~BITS_DATA_MASK;
+               switch (cflag & CSIZE) {
+                       case CS5:
+                               bits |= BITS_DATA_5;
+                               dbg("%s - data bits = 5", __FUNCTION__);
+                               break;
+                       case CS6:
+                               bits |= BITS_DATA_6;
+                               dbg("%s - data bits = 6", __FUNCTION__);
+                               break;
+                       case CS7:
+                               bits |= BITS_DATA_7;
+                               dbg("%s - data bits = 7", __FUNCTION__);
+                               break;
+                       case CS8:
+                               bits |= BITS_DATA_8;
+                               dbg("%s - data bits = 8", __FUNCTION__);
+                               break;
+                       /*case CS9:
+                               bits |= BITS_DATA_9;
+                               dbg("%s - data bits = 9", __FUNCTION__);
+                               break;*/
+                       default:
+                               DEV_ERR(&port->dev, "cp2101 driver does not "
+                                       "support the number of bits requested,"
+                                       " using 8 bit mode\n");
+                               bits |= BITS_DATA_8;
+                               break;
+               }
+               if (cp2101_set_config(port, CP2101_BITS, &bits, 2))
+                       DEV_ERR(&port->dev,"Number of data bits requested "
+                                       "not supported by device\n");
+       }
+
+       if ((cflag & (PARENB|PARODD)) != (old_cflag & (PARENB|PARODD))) {
+               cp2101_get_config(port, CP2101_BITS, &bits, 2);
+               bits &= ~BITS_PARITY_MASK;
+               if (cflag & PARENB) {
+                       if (cflag & PARODD) {
+                               bits |= BITS_PARITY_ODD;
+                               dbg("%s - parity = ODD", __FUNCTION__);
+                       } else {
+                               bits |= BITS_PARITY_EVEN;
+                               dbg("%s - parity = EVEN", __FUNCTION__);
+                       }
+               }
+               if (cp2101_set_config(port, CP2101_BITS, &bits, 2))
+                       DEV_ERR(&port->dev,"Parity mode not supported "
+                                       "by device\n");
+       }
+
+       if ((cflag & CSTOPB) != (old_cflag & CSTOPB)) {
+               cp2101_get_config(port, CP2101_BITS, &bits, 2);
+               bits &= ~BITS_STOP_MASK;
+               if (cflag & CSTOPB) {
+                       bits |= BITS_STOP_2;
+                       dbg("%s - stop bits = 2", __FUNCTION__);
+               } else {
+                       bits |= BITS_STOP_1;
+                       dbg("%s - stop bits = 1", __FUNCTION__);
+               }
+               if (cp2101_set_config(port, CP2101_BITS, &bits, 2))
+                       DEV_ERR(&port->dev,"Number of stop bits requested "
+                                       "not supported by device\n");
+       }
+
+       if ((cflag & CRTSCTS) != (old_cflag & CRTSCTS)) {
+               cp2101_get_config(port, CP2101_MODEMCTL, modem_ctl, 16);
+               dbg("%s - read modem controls = 0x%.4x 0x%.4x 0x%.4x 0x%.4x",
+                               __FUNCTION__, modem_ctl[0], modem_ctl[1],
+                               modem_ctl[2], modem_ctl[3]);
+
+               if (cflag & CRTSCTS) {
+                       modem_ctl[0] &= ~0x7B;
+                       modem_ctl[0] |= 0x09;
+                       modem_ctl[1] = 0x80;
+                       dbg("%s - flow control = CRTSCTS", __FUNCTION__);
+               } else {
+                       modem_ctl[0] &= ~0x7B;
+                       modem_ctl[0] |= 0x01;
+                       modem_ctl[1] |= 0x40;
+                       dbg("%s - flow control = NONE", __FUNCTION__);
+               }
+
+               dbg("%s - write modem controls = 0x%.4x 0x%.4x 0x%.4x 0x%.4x",
+                               __FUNCTION__, modem_ctl[0], modem_ctl[1],
+                               modem_ctl[2], modem_ctl[3]);
+               cp2101_set_config(port, CP2101_MODEMCTL, modem_ctl, 16);
+       }
+
+}
+
+static int cp2101_tiocmset (struct usb_serial_port *port, struct file *file,
+               unsigned int set, unsigned int clear)
+{
+       int control = 0;
+
+       dbg("%s - port %d", __FUNCTION__, port->number);
+
+       if (set & TIOCM_RTS) {
+               control |= CONTROL_RTS;
+               control |= CONTROL_WRITE_RTS;
+       }
+       if (set & TIOCM_DTR) {
+               control |= CONTROL_DTR;
+               control |= CONTROL_WRITE_DTR;
+       }
+       if (clear & TIOCM_RTS) {
+               control &= ~CONTROL_RTS;
+               control |= CONTROL_WRITE_RTS;
+       }
+       if (clear & TIOCM_DTR) {
+               control &= ~CONTROL_DTR;
+               control |= CONTROL_WRITE_DTR;
+       }
+
+       dbg("%s - control = 0x%.4x", __FUNCTION__, control);
+
+       return cp2101_set_config(port, CP2101_CONTROL, &control, 2);
+
+}
+
+static int cp2101_tiocmget (struct usb_serial_port *port, struct file *file)
+{
+       int control, result;
+
+       dbg("%s - port %d", __FUNCTION__, port->number);
+
+       cp2101_get_config(port, CP2101_CONTROL, &control, 1);
+
+       result = ((control & CONTROL_DTR) ? TIOCM_DTR : 0)
+               |((control & CONTROL_RTS) ? TIOCM_RTS : 0)
+               |((control & CONTROL_CTS) ? TIOCM_CTS : 0)
+               |((control & CONTROL_DSR) ? TIOCM_DSR : 0)
+               |((control & CONTROL_RING)? TIOCM_RI  : 0)
+               |((control & CONTROL_DCD) ? TIOCM_CD  : 0);
+
+       dbg("%s - control = 0x%.2x", __FUNCTION__, control);
+
+       return result;
+}
+
+static void cp2101_break_ctl (struct usb_serial_port *port, int break_state)
+{
+       int state;
+
+       dbg("%s - port %d", __FUNCTION__, port->number);
+       if (break_state == 0)
+               state = BREAK_OFF;
+       else
+               state = BREAK_ON;
+       dbg("%s - turning break %s", __FUNCTION__,
+                       state==BREAK_OFF ? "off" : "on");
+       cp2101_set_config(port, CP2101_BREAK, &state, 2);
+}
+
+static int cp2101_ioctl (struct usb_serial_port *port, struct file *file, unsigned int cmd, unsigned long arg)
+{
+       dbg("%s (%d) cmd = 0x%04x", __FUNCTION__, port->number, cmd);
+
+       switch (cmd) {
+               
+#ifndef LINUX26
+               case TIOCMGET:
+            {
+                int result = cp2101_tiocmget(port, file);
+                if (copy_to_user(&arg, &result, sizeof(int)))
+                               return -EFAULT; 
+            }
+            break;
+            
+               case TIOCMSET:
+               case TIOCMBIS:
+
+               case TIOCMBIC:
+            {
+                int val = 0;
+                
+                   if (copy_from_user(&val, &arg, sizeof(int)))
+                           return -EFAULT;
+            
+                if(cp2101_tiocmset(port, file, cmd==TIOCMBIC?0:val,  cmd==TIOCMBIC?val:0))
+                    return -EFAULT;
+            }
+            break;
+#endif
+
+               default:
+                       dbg("%s not supported = 0x%04x", __FUNCTION__, cmd);
+                       break;
+       }
+
+       return -ENOIOCTLCMD;
+}
+
+static int cp2101_startup (struct usb_serial *serial)
+{
+       /* CP2101 buffers behave strangely unless device is reset */
+       usb_reset_device(serial->dev);
+       return 0;
+}
+
+static void cp2101_shutdown (struct usb_serial *serial)
+{
+       int i;
+
+       dbg("%s", __FUNCTION__);
+
+       /* Stop reads and writes on all ports */
+       for (i=0; i < serial->num_ports; ++i) {
+#ifdef LINUX26
+               cp2101_cleanup(serial->port[i]);
+#else
+               cp2101_cleanup(&serial->port[i]);
+#endif
+       }
+}
+
+static int __init cp2101_init (void)
+{
+       int retval;
+
+       retval = usb_serial_register(&cp2101_device);
+       if (retval)
+               return retval; /* Failed to register */
+
+#ifdef LINUX26
+       retval = usb_register(&cp2101_driver);
+       if (retval) {
+               /* Failed to register */
+               usb_serial_deregister(&cp2101_device);
+               return retval;
+       }
+#endif
+       /* Success */
+       info(DRIVER_DESC " " DRIVER_VERSION);
+       return 0;
+}
+
+static void __exit cp2101_exit (void)
+{
+#ifdef LINUX26
+       usb_deregister (&cp2101_driver);
+#endif
+       usb_serial_deregister (&cp2101_device);
+}
+
+module_init(cp2101_init);
+module_exit(cp2101_exit);
+
+MODULE_DESCRIPTION(DRIVER_DESC);
+MODULE_LICENSE("GPL");
+
+#ifdef LINUX26
+MODULE_VERSION(DRIVER_VERSION);
+module_param(debug, bool, S_IRUGO | S_IWUSR);
+#else
+MODULE_PARM(debug, "i");
+#endif
+MODULE_PARM_DESC(debug, "Enable verbose debugging messages");
diff --git a/installmod b/installmod
new file mode 100644 (file)
index 0000000..2334445
--- /dev/null
@@ -0,0 +1,29 @@
+#!/bin/bash
+
+if [ -f $1 ] ; then
+       if [ ! -d $3 ] ; then
+               echo "ERR: \"$3\" does not exist."
+               exit 1
+       fi
+
+       if [ -d $2/kernel/drivers ] ; then
+               installpath=$2/kernel/drivers/usb/serial/$1
+       else
+               installpath=$2/$1
+       fi
+
+       install -m 444 -D $1 $installpath
+
+       if [ $? != 0 ] ; then
+               echo "ERR: Failed to install $1 in $installpath"
+               exit 1
+       else
+               echo "Installed $1 in $installpath"
+       fi
+
+       depmod    
+       exit 0
+else
+       echo "ERR: Module \"$1\" not present"
+       exit 1
+fi
diff --git a/rpm/buildRPM b/rpm/buildRPM
new file mode 100755 (executable)
index 0000000..dbe689b
--- /dev/null
@@ -0,0 +1,38 @@
+#!/bin/sh
+THISDIR=`pwd`
+RPMROOT=/usr/src/redhat
+NAME=cp2103
+VER_MAJ=0
+VER_MIN=11
+VER_PAT=0
+VERSION=$VER_MAJ.$VER_MIN.$VER_PAT
+
+echo $PWD
+echo "Creating infrastructure."
+cd $RPMROOT/SOURCES
+rm -rf $NAME-$VERSION
+rm -rf $NAME-$VERSION.tar.gz
+mkdir $NAME-$VERSION
+cd  $NAME-$VERSION
+
+echo "Copying source code."
+cp -R $THISDIR/. .
+echo "Packaging source code."
+cd ..
+tar cvf $NAME-$VERSION.tar $NAME-$VERSION
+gzip $NAME-$VERSION.tar
+
+echo "Copying source to RPM subsystem."
+cp $NAME-$VERSION/rpm/$NAME.spec $RPMROOT/SPECS/.
+
+echo "Starting RPM build..."
+
+KERNEL_BLD_VERSION=`uname -r`
+export KERNEL_BLD_VERSION
+
+rpmbuild -bs $RPMROOT/SPECS/cp2103.spec
+
+
+
+
+
diff --git a/rpm/cp2103.spec b/rpm/cp2103.spec
new file mode 100644 (file)
index 0000000..c5a507a
--- /dev/null
@@ -0,0 +1,34 @@
+# RPM header info
+Summary: Silicon Labs CP2101/CP2102/CP2103 USB To Serial Bridge driver
+Name: cp2103
+Version: 0.11.0
+Release: 1
+Group: System Environment/Kernel
+BuildRoot: /var/tmp/%{name}-%{version}-%{release}
+ExclusiveOS: linux
+Source: %{name}-%{version}.tar.gz
+Packager: Intelligraphics, Inc.
+Vendor: Silicon Laboratories, Inc.
+License: GPL
+
+%description
+Device driver kernel module for the Silicon Laboratories CP2101/CP2102/CP2103 USB To Serial Bridge.
+
+%prep
+%setup -q
+
+%build
+./configure
+make -f Makefile.go modules
+
+%install
+make -f Makefile.go install
+
+%clean
+make -f Makefile.go distclean
+
+%files
+%defattr(-,root,root)
+%doc
+%config
+